import java.lang.annotation.Annotation;
import java.lang.annotation.ElementType;
import java.lang.annotation.Target;
import java.lang.reflect.AnnotatedElement;

public class TargetReader {
    public TargetReader() {}

    public void readAnnotation(String classname) {
        try {
            Class cls = Class.forName(classname);

            readAnnotation(cls);
        } catch (ClassNotFoundException ex) {
            System.err.println(classname + " ܂");
        }
    }

    private void readAnnotation(AnnotatedElement element) {
        Target target = element.getAnnotation(Target.class);
        System.out.print("[" + element + "] is ");
        if (target != null) {
            ElementType[] types = target.value();
            System.out.print("annotated Target.\n    value: ");
            for (int i = 0; i < types.length; i++) {
                System.out.print(types[i] + " ");
            }
            System.out.println();
        } else {
            System.out.println("not annotated.\n");
        }
    }

    
    public static void main(String[] args) {
        if (args.length == 0) {
            System.err.println("Usage:");
            System.err.println("  java TargetReader [classname] [classname] ...");
        }

        TargetReader reader = new TargetReader();

        for (String classname : args) {
            reader.readAnnotation(classname);
        }
    }
}
